> For the complete documentation index, see [llms.txt](https://docs.virtuswap.io/virtuswap-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts.md).

# DEX Contracts

- [vPair](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vpair.md): Implements the functionality of a VirtuSwap reserve-powered AMM Pool
- [vPairFactory](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vpairfactory.md): Creates and keeps track of vPair instances and the vExchangeReserve instance
- [vRouter 1.1](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vrouter-1.1.md): VirtuSwap vRouter implements trading functionality. vRouter interacts with vPair contracts to perform the actual swaps.
- [vRouter 1.2](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vrouter-1.2.md): VirtuSwap vRouter implements trading functionality. vRouter interacts with vPair contracts to perform the actual swaps. Version 1.2 supports payable multicalls.
- [vRouter 1.3](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vrouter-1.3.md): VirtuSwap vRouter implements trading functionality by interacting with vPair contracts to perform the swaps. Version 1.3 is more gas-optimized and can use rerouting when virtual pools are locked.
- [vExchangeReserves](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vexchangereserves.md): Performs exchange of reserves of between vPair instances
- [vPoolManager](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/vpoolmanager.md): Helper contract for building and accessing VirtuSwap Virtual Pools
- [Multicall](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/multicall.md): Calls multiple ABI-encoded functions in a single atomic transaction
- [Structures](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/structures.md): Data Structures used in VirtuSwap DEX contracts
- [User Defined Value Types](https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts/user-defined-value-types.md): User Defined Value Types used in VirtuSwap DEX contracts


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.virtuswap.io/virtuswap-documentation/technical-reference/smart-contracts-v1/dex-contracts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
